package com.adventurer_engine.common.entity.ai.task;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import by;
import com.adventurer_engine.common.entity.ai.AIObject;
import com.adventurer_engine.common.entity.ai.NodeBase;
import com.adventurer_engine.common.entity.ai.NodeStatus;

public abstract class TaskBase extends NodeBase {
  protected int tick = 0;
  
  public TaskBase(AIObject ai) {
    super(ai);
  }
  
  public by writeNBT() {
    by nbt = new by();
    nbt.a("type", internalName());
    return nbt;
  }
  
  public void readNBT(by nbt) {
    assert nbt.i("type").equals(internalName());
  }
  
  public NodeStatus actionTick(NodeStatus childStatus) {
    NodeStatus tmp = onTick();
    this.tick++;
    return tmp;
  }
  
  public void init() {
    this.tick = 0;
    customInit();
  }
  
  public abstract void customInit();
  
  public abstract NodeStatus onTick();
}
